datablock ParticleData(MK14_MOD0FireParticle)
{
	dragCoefficient      = 0;
	gravityCoefficient   = -0.5;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 40;
	lifetimeVarianceMS   = 0;
	textureName          = "base/data/particles/cloud";
	spinSpeed		= 10.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;

	colors[0]     = "0.9 0.9 0 0.3";
	colors[1]     = "1 0.5 0.2 0.5";
	colors[2]     = "1 0.5 0.2 0.0";

	sizes[0]      = 0.30;
        sizes[1]      = 0.45;
	sizes[2]      = 0.24;
 
        times[0] = 0.0;
        times[1] = 0.1;
        times[2] = 1.0;

	useInvAlpha = false;
};
datablock ParticleEmitterData(MK14_MOD0FireEmitter)
{
   ejectionPeriodMS = 1;
   periodVarianceMS = 0;
   ejectionVelocity = 48.0;
   velocityVariance = 0.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 1;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "MK14_MOD0FireParticle";
};
datablock DebrisData(MK14_MOD0ShellDebris)
{
	shapeFile = "./shell.dts";
	lifetime = 2.0;
	minSpinSpeed = -400.0;
	maxSpinSpeed = 200.0;
	elasticity = 0.5;
	friction = 0.2;
	numBounces = 10;
	staticOnMaxBounce = true;
	snapOnMaxBounce = false;
	fade = true;

	gravModifier = 2;
};
datablock AudioProfile(MK14_MOD0FireSound)
{
   filename    = "./Fire.wav";
   description = AudioClose3d;
   preload = true;
};
datablock AudioProfile(MK14_MOD0ReloadSound)
{
   filename    = "./Reload.wav";
   description = AudioClose3d;
   preload = true;
};
AddDamageType("MK14_MOD0",   '<bitmap:add-ons/Weapon_MK14MOD0/ci_MK14> %1',    '%2 <bitmap:add-ons/Weapon_MK14MOD0/ci_MK14> %1',0.75,1);
datablock ProjectileData(MK14_MOD0Projectile)
{
   projectileShapeName = "add-ons/Weapon_Gun/bullet.dts";
   directDamage        = 50;
   directDamageType    = $DamageType::MK14_MOD0;
   radiusDamageType    = $DamageType::MK14_MOD0;
   brickExplosionRadius = 0;
   brickExplosionImpact = false;
   brickExplosionForce  = 0;
   brickExplosionMaxVolume = 0;
   brickExplosionMaxVolumeFloating = 0;
   impactImpulse	     = 0;
   verticalImpulse     = 0;
   explosion           = gunExplosion;
   muzzleVelocity      = 200;
   lifetime            = 8000;
   fadeDelay           = 3500;
   bounceElasticity    = 0.5;
   bounceFriction      = 0.20;
   isBallistic         = true;
   gravityMod = 0;
   hasLight    = false;
   lightRadius = 3.0;
   lightColor  = "0 0 0.5";
};
datablock ItemData(MK14_MOD0Item)
{
	category = "Weapon";
	className = "Weapon";
	shapeFile = "./MK14ITEM.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;
	uiName = "MK-14 MOD 0";
	iconName = "./icon";
	doColorShift = true;
	colorShiftColor = "0.4 0.4 0.41 1.000";
	image = MK14_MOD0Image;
	canDrop = true;
	maxAmmo = 20;
	canReload = 1;
};
datablock ShapeBaseImageData(MK14_MOD0Image)
{
   shapeFile = "./MK14MOD0.dts";
   emap = true;
   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = 0; //"0.7 1.2 -0.5";
   rotation = eulerToMatrix( "0 0 0" );
   correctMuzzleVector = true;
   className = "WeaponImage";
   item = MK14_MOD0Item;
   ammo = " ";
   projectile = MK14_MOD0Projectile;
   projectileType = Projectile;
   casing = MK14_MOD0ShellDebris;
   shellExitDir        = "1.0 0.1 1.0";
   shellExitOffset     = "0 0 0";
   shellExitVariance   = 10.0;	
   shellVelocity       = 5.0;
   melee = false;
   armReady = true;
   doColorShift = false;  
	
	stateName[0]                     	= "Activate";
	stateTimeoutValue[0]             	= 0.7;
	stateTransitionOnTimeout[0]       	= "LoadCheckA";
	StateSequence[0]			= "equip";

	stateName[1]                     	= "Ready";
	stateTransitionOnNoAmmo[1]       	= "Reload";
	stateTransitionOnTriggerDown[1]  	= "Fire";
	stateAllowImageChange[1]         	= true;	
	
	stateName[2]                    	= "Fire";
	stateTransitionOnTimeout[2]     	= "Delay";
	stateTimeoutValue[2]            	= 0.00;
	stateFire[2]                    	= true;
	stateAllowImageChange[2]        	= false;
	stateSequence[2]                	= "Fire";
	stateScript[2]                  	= "onFire";
	stateEjectShell[2]       	  	= true;
	stateEmitter[2]				= MK14_MOD0FireEmitter;
	stateEmitterTime[2]			= 0.02;
	stateEmitterNode[2]			= "muzzleNode";
	stateWaitForTimeout[2]			= true;
	StateSequence[2]			= "fire";
	stateSound[2]				= MK14_MOD0FireSound;	
	
	stateName[3]				= "Delay";
	stateTransitionOnTimeout[3]     	= "FireLoadCheckA";
	stateTimeoutValue[3]            	= 0.00;
	stateEmitter[3]				= gunSmokeEmitter;
	stateEmitterTime[3]			= 0.00;
	stateEmitterNode[3]			= "muzzleNode";

	stateName[4]				= "LoadCheckA";
	stateScript[4]				= "onLoadCheck";
	stateTimeoutValue[4]			= 0.00;
	stateTransitionOnTimeout[4]		= "LoadCheckB";	
	
	stateName[5]				= "LoadCheckB";
	stateTransitionOnAmmo[5]		= "Ready";
	stateTransitionOnNoAmmo[5]		= "ReloadWait";	

	stateName[6]				= "ReloadWait";
    stateTimeoutValue[6]			= 0;
	stateTransitionOnTimeout[6]		= "Reload";
	stateWaitForTimeout[6]			= true;	
	
	stateName[7]				= "Reload";
	stateTimeoutValue[7]			= 0.9;
	stateScript[7]				= "onReloadStart";
	stateTransitionOnTimeout[7]		= "ReloadB";
	stateWaitForTimeout[7]			= true;
	StateSequence[7]			= "OUT";
	stateSound[7]				= MK14_MOD0ReloadSound;
	
	stateName[8]				= "ReloadB";
	stateTimeoutValue[8]			= 1.4;
	stateTransitionOnTimeout[8]		= "Reloaded";
	stateWaitForTimeout[8]			= true;
	StateSequence[8]			= "IN";	
	
	stateName[9]				= "Reloaded";
	stateTimeoutValue[9]			= 1.0;
	stateScript[9]				= "onReloaded";
	stateTransitionOnTimeout[9]		= "Ready";
	stateSequence[9]                = "BoltPull";
	
	stateName[10] 				= "Smoke";
	stateEmitter[10]			= gunSmokeEmitter;
	stateEmitterTime[10]			= 0.3;
	stateEmitterNode[10]			= "muzzleNode";
	stateTimeoutValue[10]			= 0.0;
	stateTransitionOnTriggerUp[10]     = "Ready";	
	
	stateName[11] 				= "ReloadSmoke";
	stateEmitter[11]			= gunSmokeEmitter;
	stateEmitterTime[11]			= 0.0;
	stateEmitterNode[11]			= "muzzleNode";
	stateTimeoutValue[11]			= 0.0;
	stateTransitionOnTimeout[11]		= "Reload";
	
	stateName[12]				= "FireLoadCheckA";
	stateScript[12]				= "onLoadCheck";
	stateTimeoutValue[12]			= 0.00;
	stateTransitionOnTimeout[12]		= "FireLoadCheckB";
	
	stateName[13]				= "FireLoadCheckB";
	stateTransitionOnAmmo[13]		= "Smoke";
	stateTransitionOnNoAmmo[13]		= "ReloadSmoke";
};
function MK14_MOD0Projectile::onAdd(%datablock, %projectile) {
	%projectile.initialVelocity = vectorScale(vectorNormalize(%projectile.initialVelocity), 16000);
}
function MK14_MOD0Image::onFire(%this,%obj,%slot)
{
	if(vectorLen(%obj.getVelocity()) < 0.1 && (getSimTime() - %obj.lastShotTime) > 50)
	{
		%projectile = MK14_MOD0Projectile;
		%spread = 0.000;
	}
	else
	{
		%projectile = MK14_MOD0Projectile;
		%spread = 0.0001;
	}
	
	%obj.lastShotTime = getSimTime();
	%shellcount = 1;

	%obj.playThread(2, root);
	%shellcount = 1;
	%obj.toolAmmo[%obj.currTool]--;

	for(%shell=0; %shell<%shellcount; %shell++)
	{
		%vector = %obj.getMuzzleVector(%slot);
		%objectVelocity = %obj.getVelocity();
		%vector1 = VectorScale(%vector, %projectile.muzzleVelocity);
		%vector2 = VectorScale(%objectVelocity, %projectile.velInheritFactor);
		%velocity = VectorAdd(%vector1,%vector2);
		%x = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%y = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%z = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
		%velocity = MatrixMulVector(%mat, %velocity);

		%p = new (%this.projectileType)()
		{
			dataBlock = %projectile;
			initialVelocity = %velocity;
			initialPosition = %obj.getMuzzlePoint(%slot);
			sourceObject = %obj;
			sourceSlot = %slot;
			client = %obj.client;
		};
		MissionCleanup.add(%p);
	}
	return %p;
}
function MK14_MOD0Image::onLoadCheck(%this,%obj,%slot)
{
	if(%obj.toolAmmo[%obj.currTool] <= 0)
    	%obj.setImageAmmo(%slot,0);
	else
	    %obj.setImageAmmo(%slot,1);
}
function MK14_MOD0Image::onReloaded(%this,%obj,%slot)
{
	%obj.toolAmmo[%obj.currTool] = 20;
	%obj.setImageAmmo(%slot,1);
}
function MK14_MOD0Image::onMount(%this, %obj, %slot)  
{	
	%obj.hidenode("RHand");
    %obj.hidenode("LHand");
}
function MK14_MOD0Image::onUnMount(%this, %obj, %slot) 
{	
	%obj.unhidenode("RHand");
    %obj.unhidenode("LHand");
}